unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, OleServer, MSXML2_TLB, ActiveX, ComObj;

type
  TMyOtherSaxHandler = class(TInterfacedObject, ISAXContentHandler)
  public
    // IInterface
    function GetTypeInfoCount(out Count: Integer): HResult; stdcall;
    function GetTypeInfo(Index, LocaleID: Integer; out TypeInfo): HResult; stdcall;
    function GetIDsOfNames(const IID: TGUID; Names: Pointer;
      NameCount, LocaleID: Integer; DispIDs: Pointer): HResult; stdcall;
    function Invoke(DispID: Integer; const IID: TGUID; LocaleID: Integer;
      Flags: Word; var Params; VarResult, ExcepInfo, ArgErr: Pointer): HResult; stdcall;

    // IVBSAXContentHandler
    function startDocument: HRESULT; stdcall;
    function characters(var pwchChars: Word; cchChars: Integer): HRESULT;
      stdcall;
    function endDocument: HRESULT; stdcall;
    function endElement(var pwchNamespaceUri: Word;
      cchNamespaceUri: Integer; var pwchLocalName: Word;
      cchLocalName: Integer; var pwchQName: Word;
      cchQName: Integer): HRESULT; stdcall;
    function endPrefixMapping(var pwchPrefix: Word;
      cchPrefix: Integer): HRESULT; stdcall;
    function ignorableWhitespace(var pwchChars: Word;
      cchChars: Integer): HRESULT; stdcall;
    function processingInstruction(var pwchTarget: Word;
      cchTarget: Integer; var pwchData: Word; cchData: Integer): HRESULT;
      stdcall;
    function putDocumentLocator(const pLocator: ISAXLocator): HRESULT;
      stdcall;
    function skippedEntity(var pwchName: Word; cchName: Integer): HRESULT;
      stdcall;
    function startElement(var pwchNamespaceUri: Word;
      cchNamespaceUri: Integer; var pwchLocalName: Word;
      cchLocalName: Integer; var pwchQName: Word; cchQName: Integer;
      const pAttributes: ISAXAttributes): HRESULT; stdcall;
    function startPrefixMapping(var pwchPrefix: Word; cchPrefix: Integer;
      var pwchUri: Word; cchUri: Integer): HRESULT; stdcall;
  end;


  TfrmSAX = class(TForm)
    Label1: TLabel;
    btnAbortSAX: TButton;
    mXML: TMemo;
    procedure btnAbortSAXClick(Sender: TObject);
  private
    { Private declarations }
    sax: ISAXXMLReader;    
  public
    { Public declarations }
  end;

var
  frmSAX: TfrmSAX;

implementation

{$R *.dfm}

var EventLog: TStrings;
    s : string;

(* ************************************************************************* *)

procedure TfrmSAX.btnAbortSAXClick(Sender: TObject);
var sXML : string;
begin
  sXML := '<?xml version="1.0"?>';
  sXML := sXML + '<root>';
  sXML := sXML + '<node>CARRY ON</node>';
  sXML := sXML + '<node>STOP</node>';
  sXML := sXML + '<node>This node is not parsed</node>';
  sXML := sXML + '<node>neither is this one</node>';
  sXML := sXML + '</root>';

  mXML.Clear;
  EventLog := mXML.Lines;
  sax := CoSAXXMLReader.Create as ISAXXMLReader;

  sax.putContentHandler(TMyOtherSaxHandler.Create);
  sax.parse(sXML);
end;

(* ************************************************************************* *)

function TMyOtherSaxHandler.characters(var pwchChars: Word;
  cchChars: Integer): HRESULT;
begin
  WideCharLenToStrVar(@pwchChars, cchChars, s);
  EventLog.Add ('EVENT : characters : ' + s);

  if s = 'STOP' then
    result:=E_FAIL
  else
    result:=S_OK;
end;

function TMyOtherSaxHandler.endDocument: HRESULT;
begin
  EventLog.Add('END DOCUMENT:');
  result:=S_OK;
end;

function TMyOtherSaxHandler.endElement(var pwchNamespaceUri: Word;
  cchNamespaceUri: Integer; var pwchLocalName: Word; cchLocalName: Integer;
  var pwchQName: Word; cchQName: Integer): HRESULT;
begin
  WideCharLenToStrVar(@pwchLocalName, cchLocalName, s);
  EventLog.Add('END ELEMENT:' + s);
  result:=S_OK;
end;

function TMyOtherSaxHandler.startDocument: HRESULT;
begin
  EventLog.Add('START DOCUMENT');
  result:=S_OK;
end;

function TMyOtherSaxHandler.startElement(var pwchNamespaceUri: Word;
  cchNamespaceUri: Integer; var pwchLocalName: Word; cchLocalName: Integer;
  var pwchQName: Word; cchQName: Integer;
  const pAttributes: ISAXAttributes): HRESULT;
begin
  WideCharLenToStrVar(@pwchLocalName, cchLocalName, s);
  EventLog.Add('START ELEMENT:' +s);
  result:=S_OK;
end;

function TMyOtherSaxHandler.endPrefixMapping(var pwchPrefix: Word;
  cchPrefix: Integer): HRESULT;
begin
  result:=S_OK;
end;

function TMyOtherSaxHandler.startPrefixMapping(var pwchPrefix: Word;
  cchPrefix: Integer; var pwchUri: Word; cchUri: Integer): HRESULT;
begin
  result:=S_OK;
end;

function TMyOtherSaxHandler.ignorableWhitespace(var pwchChars: Word;
  cchChars: Integer): HRESULT;
begin
  result:=S_OK;
end;

function TMyOtherSaxHandler.processingInstruction(var pwchTarget: Word;
  cchTarget: Integer; var pwchData: Word; cchData: Integer): HRESULT;
begin
  result:=S_OK;
end;

function TMyOtherSaxHandler.putDocumentLocator(
  const pLocator: ISAXLocator): HRESULT;
begin
  result:=S_OK;
end;

function TMyOtherSaxHandler.skippedEntity(var pwchName: Word;
  cchName: Integer): HRESULT;
begin
  result:=S_OK;
end;

(* ************************************************************************* *)

function TMyOtherSaxHandler.GetIDsOfNames(const IID: TGUID; Names: Pointer;
  NameCount, LocaleID: Integer; DispIDs: Pointer): HResult;
begin
  Result := E_NOTIMPL;
end;

function TMyOtherSaxHandler.GetTypeInfo(Index, LocaleID: Integer;
  out TypeInfo): HResult;
begin
  Result := E_NOTIMPL;
end;

function TMyOtherSaxHandler.GetTypeInfoCount(out Count: Integer): HResult;
begin
  Result := E_NOTIMPL;
end;

function TMyOtherSaxHandler.Invoke(DispID: Integer; const IID: TGUID;
  LocaleID: Integer; Flags: Word; var Params; VarResult, ExcepInfo,
  ArgErr: Pointer): HResult;
begin
  Result := E_NOTIMPL;
end;

(* ************************************************************************* *)

end.
